package apps.arithmetic;

import cj.appkit.FilterAppKit;
import cj.volume.MCVolume;
import cj.volume.process.*;

final public class ArithmeticApp {
   public static void main(String argv[]) { new ArithmeticKit().main(argv); }
}

final class ArithmeticKit extends FilterAppKit 
{
	private double toadd = 0.0;
	private double tosubtract = 0.0;
	private double tomultiply = 1.0;
	private double todivide = 1.0;

    private String comment;
	private String output_suffix = "_arith";

	public String getAppName() { return "arithmetic"; }
	public String getDialogName() { return "Process image"; }
    public String getOutputSuffix() { return output_suffix; }
    public String getComment() { return comment; }

    protected void moreOpts() { 
        addOpt_reqArg("add", 'a', "Add a constant.");
        addOpt_reqArg("subtract", 's', "Subtract a constant.");
        addOpt_reqArg("multiply", 'm', "Multiply by a constant.");
        addOpt_reqArg("divide", 'd', "Divide by a constant.");
        addOpt_reqArg("output-suffix", 800, "Output suffix (def: 'A').");
    }

    protected boolean parseArg(int c)
    {
    	switch(c) {
			case 'a':
				toadd = getDoubleArg("to add");
				break;
			case 's':
				tosubtract = getDoubleArg("to subtract");
				break;
			case 'm':
				tomultiply = getDoubleArg("to multiply");
				break;
			case 'd':
				todivide = getDoubleArg("to divide");
				break;
			case 800:
				output_suffix = getStringArg("suffix");
				break;
			default:
				return false;
		}
		return true;
    }

	final public void initParams(MCVolume v)
	{
	}

    final public void printArgs()
   	{
   	}

    final public MCVolume filter(MCVolume v)
	{
		if( toadd != 0.0 ) Arithmetic.add(v, toadd);
		if( tosubtract != 0.0 ) Arithmetic.subtract(v, tosubtract);
		if( tomultiply != 1.0 ) Arithmetic.multiply(v, tomultiply);
		if( todivide != 1.0 ) Arithmetic.divide(v, todivide);
		return v;
	}
}
