package apps.nnlsdisp;

import javax.swing.*;
import java.io.*;

import cj.fileformats.*;

class Test {


	public static void main(String args[]) {

		int nslices;
		String filename = "";

		//--------------------------------------------------------------------
		//
		//  Parse the command line arguments.
		//
		if( args.length > 0 ) {
			int argnum = 0;
			do {

				if( args[argnum].equals("-help") || args[argnum].equals("--help")) {
					System.out.println("java Test <filename>.bff");
					System.exit(0);
				}
				else {
					filename = args[argnum];
				}

				argnum++;
			} while( argnum < args.length );
		}

        if( filename.compareTo("") == 0 ) {
			filename = "./";
		}

		//--------------------------------------------------------------------
		//
		//  Check to see if the thing in "filename" is a directory or a file.
		//
        if( (new File(filename)).isDirectory() ) {
            //
            //  If it is a directory, then bring up the dialog to get the file
            //
            JFrame dialogFrame = new JFrame("Show image");
            JFileChooser fd = new JFileChooser(filename);
            int returnVal = fd.showOpenDialog(dialogFrame);
            JDialog jt = new JDialog(dialogFrame, "Loading data...");

			//  if they hit cancel then we quit.
            if( returnVal == JFileChooser.CANCEL_OPTION ) {
                System.exit(0);
            }

			try {
				filename = fd.getSelectedFile().getCanonicalPath();
			}
			catch(IOException e ) {}
        }

		//--------------------------------------------------------------------
		//
		//  Load up the BFF file.
		//
		BFF b = new BFF(filename);
		b.show();

		DisplayMCVolume dm = new DisplayMCVolume(filename, b.getMCVolume(), b.getTE() );
	}
}
