import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;

// This applet creates an image from an array of color values
// and displays it.

public class DisplayImage extends Applet
{

	public static int imageData[];
	public static JFrame appletFrame;
	public static JSlider slider;
	public Image image;
	public JPanel jp_image;
	public JPanel jp_slider;
	public JFrame jf;
	public JSlider js;
	public MemoryImageSource mi;

   public static void main(String args[])
   {

		DisplayImage t = new DisplayImage();

		t.init();
		t.start();
	}

	public static short swapShort(short s) {
		return (short)((s&0x00FF)<<8 | (s&0xFF00)>>8);
	}

	public void readData()
	{
        FileInputStream fis;
        DataInputStream ds;
        short ii;

        try {
            fis = new FileInputStream("/home/craig/work/Data/MRI/Anne_CPMG/ag43531_002.m2f");
            ds = new DataInputStream(fis);
        } catch(IOException e) { return; }

        try {

			//-----------------------------------------------------------
			// 
			//  Create the progress bar.
			//
			JProgressBar jpb = new JProgressBar(1, 10);
			jpb.setSize(200,50);

			JFrame jf_jpb = new JFrame("Loading Volume");
			jf_jpb.setSize(200,50);
			jf_jpb.getContentPane().add(jpb);

			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

			System.out.println("Height is " + screenSize.height + " and width is " + screenSize.width);

			jf_jpb.setLocation(
				new Point((screenSize.width-200)/2, (screenSize.height-50)/2));
			jf_jpb.setVisible(true);

			imageData = new int[256*256];

			//-----------------------------------------------------------
			// 
			//  Read in the data.
			//
			System.out.println("Readin in the data");
			for( int jj=0; jj < 256*256; jj++) { 
				imageData[jj] = (int)swapShort(ds.readShort());

				if( (jj % (256*256)) == 0 ) {
					jpb.setValue( jj / (256*256) );
				}
			}

			jf_jpb.dispose();

        } catch (IOException e) { return; }

		
	}

   public void init()
   {
		jf = new JFrame("DisplayImage");

		readData();

		js = new JSlider(JSlider.HORIZONTAL, 1, 24, 1);
		js.setMajorTickSpacing(5);
		js.setMinorTickSpacing(1);
		js.setPaintTicks(true);
		js.setPaintLabels(true);
		// c.setSize(10,256);

		//  Create gridbaglayout
		//jf.getContentPane().setLayout(new BorderLayout(2,1));

		//  Add canvas and slider to frame.
		jp_image = new JPanel();
		jp_image.setSize(256,256);
		jp_image.setPreferredSize(new Dimension(256,256));
		jp_image.setBorder(BorderFactory.createTitledBorder("Image"));
		jf.getContentPane().add(jp_image, BorderLayout.NORTH);

		jp_slider = new JPanel();
		jp_slider.setSize(256, 10);
		jp_slider.setBorder(BorderFactory.createTitledBorder("Image Number"));
		jf.getContentPane().add(jp_slider, BorderLayout.SOUTH);
		jp_slider.add(js);

		System.out.println("Here");
		if( imageData == null ){
			System.out.println("imageData is null");
			System.exit(0);
		}

		//  Create image and put it into jp_image panel.
		mi = new MemoryImageSource(256,256, imageData, 0, 256);

		if( mi == null ){
			System.out.println("Memroyimage is null");
			System.exit(0);
		}

		System.out.println("There");
		image = createImage(mi);

		if( image == null ){
			System.out.println("Image is null");
			System.exit(0);
		}

		System.out.println("Yo");
		jf.setSize(400, 400);
		jf.setVisible(true);

		// System.out.println("Where");
		// jp_image.getGraphics().drawImage(image,0,0,256,256,this);
		jp_image.setVisible(true);
   }

	public void paint(Graphics g)
	{
		// g.drawImage(image, 0, 0, 256, 256, this);
		jp_image.getGraphics().drawImage(image, 0, 0, 256, 256, this);
		// jp_image.setVisible(true);
	}

}
