import java.awt.*;
import java.applet.*;
import org.netlib.util.*;
import cj.*;
import apps.simple_programs.Fortran2Java.nnls.cj.Nnls;

public class Test3
{
    private double[] te = null;
    private double[] t2 = null;
    private double[] b = null;
    private double[] x = null;
    private double[] A = null;
    private int ncols, nrows, ndata;

    //
    //  NNLS working variables.
    //
    Nnls nnls;
    private double[] w;
    private double[] zz;
    doubleW rnorm;
    int[] index;
    intW mode;

    public static void main(String args[])
    {
        Test3 t = new Test3();
    }

    public Test3()
    {
        nnls = new Nnls();

        //
        //  Setup the te's and t2's... create the A matrix
        //
        setupA();

        //
        //  Now setup the working arrays for NNLS.
        //
        setupNNLS();

        //
        //  Call NNLS.
        //
        nnls.nnls(A, 0, nrows, nrows, ncols, b, 0, x, 0, rnorm,
                 w, 0, zz, 0, index, 0, mode);
        System.out.println("Rnorm is " + rnorm.val);
        System.out.println("Mode is " + mode.val);

        //
        //  Print out the result.
        //
        for(int ii=0; ii<x.length; ii++) {
            if( x[ii] > 0.0 ) {
                System.out.println("" + x[ii] + " " + t2[ii]);
            }
        }
    }

    private void setupA() {
        //
        //  Setup the te's and t2's... create the A matrix
        //
        int ii;

        nrows = 5;
        ncols = 10;
        ndata = nrows;

        //
        //  Setup te
        //
        te= new double[nrows];
        for(ii=1; ii<=nrows; ii++) {
            te[ii-1] = ((double)ii*10.0);
        }

        //
        //  Setup t2 and x
        //
        x = new double[ncols];
           t2= new double[ncols];
        for(ii=1; ii<=ncols; ii++) {
            t2[ii-1] = ((double)ii)*10.0;
        }

        //
        //  Setup b
        //
        b = new double[nrows];
        for( ii=0; ii<nrows; ii++) {
            b[ii] = Math.exp(-te[ii] / 40.0);
            System.out.println("b " + b[ii]);
        }

        //
        //  Setup A
        //
        A = new double[nrows*ncols];
        for(ii=0; ii<nrows*ncols; ii++) {
            A[ii] = Math.exp( - te[ii%nrows] / t2[ii/nrows] );
        }

        for(int row=0; row<nrows; row++) {
            for(int col=0; col<ncols; col++) {
                Format.print(System.out, "%5.4f ", A[row*ncols+col]);
            }
            System.out.println();
        }
    }

    private void setupNNLS() {
        try {
            w = new double[ncols];
            zz = new double[nrows];
            index = new int[ncols];
        }
        catch (Exception e) {
            System.err.println("Caught IOException: " + e.getMessage());
            System.exit(0);
        }

        for( int ii=0; ii<nrows; ii++) {
            zz[ii] = 0;
        }

        for( int ii=0; ii<ncols; ii++) {
            w[ii] = 0.0;
            index[ii] = 0;
        }

        mode = new intW(0);
        rnorm = new doubleW(0.0);
    }

}
