package apps.simple_programs.Fortran2Java.nnls.cj;/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: nnls.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;



public class G1 {

// C      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
// C$$$$$ CALLS NO OTHER ROUTINES 
// C 
// C 
// C 
// C 
// C  FROM LAWSON+HANSON -SOLVING LEAST SQUARES PROBLEMS- 1974 P 309. 
// C  COMPUTES AN ORTHOGONAL MATRIX TO ROTATE (A,B) INTO (SQRT(A*A+B*B
// C  MATRIX IN FORM (COSA, SINA/-SINA, COSA) AND SIG HOLDS MAGNITUDE OF 
// C  (A,B).  SIG IS ALLOWED TO OVERWRITE A OR B IN CALLING ROUTINE. 
// C 
    static double zero= 0.0;
    static double one= 0.0;
    static double xr= 0.0;
    static double yr= 0.0;

    public static void g1 (double a,
                           double b,
                           doubleW cosa,
                           doubleW sina,
                           doubleW sig)  {

        zero = 0.0;
        one = 1.0;
        if (Math.abs(a) <= Math.abs(b))
            Dummy.go_to("G1",10);
        xr = b/a;
        yr = Math.sqrt(one+Math.pow(xr, 2));
        cosa.val = (double)(Dsign.dsign(one/yr,a));
        sina.val = cosa.val*xr;
        sig.val = Math.abs(a)*yr;
        Dummy.go_to("G1",999999);
        label10:
        Dummy.label("G1",10);
        if ((b) < 0)
            Dummy.go_to("G1",20);
        else if ((b) == 0)
            Dummy.go_to("G1",30);
        else   Dummy.go_to("G1",20);
        label20:
        Dummy.label("G1",20);
        xr = a/b;
        yr = Math.sqrt(one+Math.pow(xr, 2));
        sina.val = (double)(Dsign.dsign(one/yr,b));
        cosa.val = sina.val*xr;
        sig.val = Math.abs(b)*yr;
        Dummy.go_to("G1",999999);
        label30:
        Dummy.label("G1",30);
        sig.val = zero;
        cosa.val = zero;
        sina.val = one;
        Dummy.go_to("G1",999999);
        Dummy.label("G1",999999);
        return;
    }
} // End class.
