/* nnls.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__0 = 0;
static integer c__2 = 2;

/* Subroutine */ int nnls_(doublereal *a, integer *mdim, integer *m, integer *
	n, doublereal *b, doublereal *x, doublereal *rnorm, doublereal *w, 
	doublereal *zz, integer *index, integer *mode)
{
    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2;
    doublereal d__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer iter;
    static doublereal temp, wmax;
    static integer next;
    static doublereal zero;
    static integer i__, j, l;
    static doublereal t, alpha, asave;
    static integer itmax, izmax, nsetp;
    extern /* Subroutine */ int g1_(doublereal *, doublereal *, doublereal *, 
	    doublereal *, doublereal *);
    static doublereal dummy[1];
    extern /* Subroutine */ int g2_(doublereal *, doublereal *, doublereal *, 
	    doublereal *);
    static doublereal unorm, ztest, cc;
    extern /* Subroutine */ int h12_(integer *, integer *, integer *, integer 
	    *, doublereal *, integer *, doublereal *, doublereal *, integer *,
	     integer *, integer *);
    static integer ii, jj, ip;
    static doublereal sm;
    static integer iz, jz;
    static doublereal up, ss, factor;
    static integer iz1, iz2;
    static doublereal one, two;
    static integer npp1;

/*      IMPLICIT DOUBLE PRECISION (A-H,O-Z) */
/* $$$$$$ CALLS H12,G1,G2 */
/* NON-NEGATIVE LEAST-SQUARES FITTING ROUTINE.  GIVEN BY LAWSON + HANSON 
*/
/*  IN  SOLVING LEAST SQUARES PROBLEMS ,PRENTICE-HALL 1974. */
/*  GIVEN  MATRIX  A  (M BY N), AND AN M-VECTOR  B  , FINDS THE N-VECTOR 
*/
/*  X  THAT SOLVES THE PROBLEM 2-NORM(A*X - B) MINIMUM WITH X.GE.0 */

/*  A(),MDIM,M,N  A  IS THE ARRAY, WITH MROWS,  N  COLS.  MDIM  IS THE */
/*     ACTUAL DIMENSION GIVEN  A  IN THE CALLING PROGRAM (MDIM.GE.M) */
/*     A  IS DESTROYED BY PROGRAM. */
/*  B()  ON ENTRY MUST CONTAIN M-VECTOR  B.  DESTROYED BY PROGRAM */
/*  X()  SOLUTION VECTOR  X.  NEED NOT BE INITIALIZED. */
/*  RNORM  MINIMUM TWO-NORM. */
/*  W()  AN ARRAY OF WORKING SPACE.  MUST BE DIMENSIONED AT LEAST N */
/*  ZZ()  ANOTHER WORKING ARRAY.  MUST BE DIMENSIONED AT LEAST M. */
/*  INDEX  ANOTHER WORKING ARRAY. MUST BE DIMENSIONED AT LEAST  N. */
/*  MODE  A FLAG INDICATENG OUTCOME OF SUBROUTINE. */
/*     MODE=1   MEANS ROUTINE WORKED PROPERLY. */
/*     MODE=2   MEANS DIMENSIONS OF ARRAYS WERE BAD (M.LE0 .OR. N.LE.0) */
/*     MODE=3   MEANS ITERATION COUNT EXCEEDED (MORE THAN 3*N ITERATI */


    /* Parameter adjustments */
    --zz;
    --b;
    --index;
    --w;
    --x;
    a_dim1 = *mdim;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    zero = 0.f;
    one = 1.f;
    two = 2.f;
    factor = .01f;

    *mode = 1;
    if (*m > 0 && *n > 0) {
	goto L10;
    }
    *mode = 2;
    return 0;
L10:
    iter = 0;
    itmax = *n * 3;


/*  INITIALIZE ARRAYS INDEX  AND  X */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	x[i__] = zero;
/* L20: */
	index[i__] = i__;
    }

    iz2 = *n;
    iz1 = 1;
    nsetp = 0;
    npp1 = 1;
/*     C  MAIN LOOP BEGINS HERE */
L30:

/*  QUIT IF ALL COEFFS ARE ALREADY IN SOLUTION. OR IF M COLS OF A HAVE */
/*  BEEN TRIANGULARIZED. */
    if (iz1 > iz2 || nsetp >= *m) {
	goto L350;
    }


/*  COMPUT COMPONENTS OF DUAL VECTOR W */
    i__1 = iz2;
    for (iz = iz1; iz <= i__1; ++iz) {
	j = index[iz];
	sm = zero;
	i__2 = *m;
	for (l = npp1; l <= i__2; ++l) {
/* L40: */
	    sm = a[l + j * a_dim1] * b[l] + sm;
	}
/* L50: */
	w[j] = sm;
    }
/*  FIND LARGEST +VE W(J) */
L60:
    wmax = zero;
    i__1 = iz2;
    for (iz = iz1; iz <= i__1; ++iz) {
	j = index[iz];
	if (w[j] <= wmax) {
	    goto L70;
	}
	wmax = w[j];
	izmax = iz;
L70:
	;
    }



/*  IF WMAX.LE.0 GO TO TERMINATION (KUHN-TUCKER CONDITIONS OK) */
    if (wmax <= 0.) {
	goto L350;
    } else {
	goto L80;
    }
L80:
    iz = izmax;
    j = index[iz];



/*  DSIGN OF W(J) IS OK FOR J TO BE MOVED TO SET  P. */
/*  BEGIN HOUSE-HOLDER TRANS. CHECK NEW DIAGONAL ELEMENT TO AVOID NEAR */
    asave = a[npp1 + j * a_dim1];
    i__1 = npp1 + 1;
    h12_(&c__1, &npp1, &i__1, m, &a[j * a_dim1 + 1], &c__1, &up, dummy, &c__1,
	     &c__1, &c__0);
    unorm = zero;
    if (nsetp == 0) {
	goto L100;
    }
    i__1 = nsetp;
    for (l = 1; l <= i__1; ++l) {
/* L90: */
/* Computing 2nd power */
	d__1 = a[l + j * a_dim1];
	unorm = d__1 * d__1 + unorm;
    }
L100:
    unorm = sqrt(unorm);
    temp = unorm + (d__1 = a[npp1 + j * a_dim1], abs(d__1)) * factor;
    if (temp - unorm <= 0.) {
	goto L130;
    } else {
	goto L110;
    }
/*  COL J IS SUFFICIENTLY INDEP. COPY  B  TO ZZ. UPDATE  Z  AND SOLVE */
/*  FOR  ZTEST (=PROPOSED NEW VAL FOR X(J)) */

L110:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L120: */
	zz[l] = b[l];
    }
    i__1 = npp1 + 1;
    h12_(&c__2, &npp1, &i__1, m, &a[j * a_dim1 + 1], &c__1, &up, &zz[1], &
	    c__1, &c__1, &c__1);
    ztest = zz[npp1] / a[npp1 + j * a_dim1];


/*              SEE IF  ZTEST IS +VE */
    if (ztest <= 0.) {
	goto L130;
    } else {
	goto L140;
    }

/*  REJECT  J  AS A CANDIDATE TO BE MOVED FROM SET  Z  TO SET  P . */
/*  RESTORE A(NPP1,J), SET W(J)=0. AND LOOP BACK TO TEST DUAL */
/*  COEFFFS AGAIN. */

L130:
    a[npp1 + j * a_dim1] = asave;
    w[j] = zero;
    goto L60;

/*  THE INDEX J=INDEX(IZ) HAS BEEN SELECTED TO BE MOVED FTOM SET  Z */
/*  TO SET  P .  UPDATE B,  UPDATE INDICES, APPLY HOUSEHOLDER TRANS */
/*  TO COLS IN NEW SET Z.  ZERO SUBDIAGONAL  ELTS IN COL  J, SET */
/*  W(J)=0. */

L140:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L150: */
	b[l] = zz[l];
    }

    index[iz] = index[iz1];
    index[iz1] = j;
    ++iz1;
    nsetp = npp1;
    ++npp1;

    if (iz1 > iz2) {
	goto L170;
    }
    i__1 = iz2;
    for (jz = iz1; jz <= i__1; ++jz) {
	jj = index[jz];
/* L160: */
	h12_(&c__2, &nsetp, &npp1, m, &a[j * a_dim1 + 1], &c__1, &up, &a[jj * 
		a_dim1 + 1], &c__1, mdim, &c__1);
    }
L170:

    if (nsetp == *m) {
	goto L190;
    }
    i__1 = *m;
    for (l = npp1; l <= i__1; ++l) {
/* L180: */
	a[l + j * a_dim1] = zero;
    }
L190:

    w[j] = zero;
/*  SOLVE TRIANGULAT SYSTEM. STORE SOL IN ZZ,TEMPORARILY */

    next = 1;
    goto L400;
L200:




/*  SECONDARY LOOP BEFINS HERE */
L210:
    ++iter;
    if (iter <= itmax) {
	goto L220;
    }
    *mode = 3;
/*  WRITE STATEMENT HERE DELETED********************* */
    goto L350;
L220:



/*  SEE IF ALL NEW CONSTRAINED COEFFS ARE FEASIBLE. IF NOT, FIND ALPHA */
    alpha = two;
    i__1 = nsetp;
    for (ip = 1; ip <= i__1; ++ip) {
	l = index[ip];
	if (zz[ip] <= 0.) {
	    goto L230;
	} else {
	    goto L240;
	}

L230:
	t = -x[l] / (zz[ip] - x[l]);
	if (alpha <= t) {
	    goto L240;
	}
	alpha = t;
	jj = ip;
L240:
	;
    }
/*  IF ALL NEW CONSTRAINED COEFFS ARE FEASIBLE, ALPHA IS STILL 2. IF S */
/*  EXIT INTO MAIN LOOP. */


    if (alpha == two) {
	goto L330;
    }
/*  OTHERWISE ALPHA WILL BE IN (0,1) TO INTERPOLATE BETWEEN OLDX */



    i__1 = nsetp;
    for (ip = 1; ip <= i__1; ++ip) {
	l = index[ip];
/* L250: */
	x[l] = alpha * (zz[ip] - x[l]) + x[l];
    }

/*  MODIFY  A  BB  AND THE INDEX ARRAYS TO MOVE COEFF  I */
/*  FROM  SET  P  TO SET  Z. */

    i__ = index[jj];
L260:
    x[i__] = zero;

    if (jj == nsetp) {
	goto L290;
    }
    ++jj;
    i__1 = nsetp;
    for (j = jj; j <= i__1; ++j) {
	ii = index[j];
	index[j - 1] = ii;
	g1_(&a[j - 1 + ii * a_dim1], &a[j + ii * a_dim1], &cc, &ss, &a[j - 1 
		+ ii * a_dim1]);
	a[j + ii * a_dim1] = zero;
	i__2 = *n;
	for (l = 1; l <= i__2; ++l) {
	    if (l != ii) {
		g2_(&cc, &ss, &a[j - 1 + l * a_dim1], &a[j + l * a_dim1]);
	    }
/* L270: */
	}
/* L280: */
	g2_(&cc, &ss, &b[j - 1], &b[j]);
    }
L290:
    npp1 = nsetp;
    --nsetp;
    --iz1;
    index[iz1] = i__;
/*  ALL COEFFS IN SET P SHOULD BE FEASIBLE.  IF THEY ARE NOT */
/*  TO ROUND-OFF.  NON-POSITIVE ONES SET TO 0 AND MOVED TO . */





    i__1 = nsetp;
    for (jj = 1; jj <= i__1; ++jj) {
	i__ = index[jj];
	if (x[i__] <= 0.) {
	    goto L260;
	} else {
	    goto L300;
	}
L300:
	;
    }


/*  COPY  B  TO  ZZ  AND SOLVE AGAIN AND LOOP BACK. */
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L310: */
	zz[i__] = b[i__];
    }
    next = 2;
    goto L400;
L320:
    goto L210;

/*  END OF SECONDARY LOOP */
L330:
    i__1 = nsetp;
    for (ip = 1; ip <= i__1; ++ip) {
	i__ = index[ip];
/* L340: */
	x[i__] = zz[ip];
    }
/*  ALL NEW COEFFS ARE +VE.  LOOP BACK TO BEGINNING. */
    goto L30;
/*  END OF MAIN LOOP */
/*  TERMINATING SECTION */




L350:
    sm = zero;
    if (npp1 > *m) {
	goto L370;
    }
    i__1 = *m;
    for (i__ = npp1; i__ <= i__1; ++i__) {
/* L360: */
/* Computing 2nd power */
	d__1 = b[i__];
	sm = d__1 * d__1 + sm;
    }
    goto L390;
L370:
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
/* L380: */
	w[j] = zero;
    }
L390:
    *rnorm = sqrt(sm);
    return 0;

/*  SOLUTION OF LINEAR TRIANGULAR SYSTEM */


L400:
    i__1 = nsetp;
    for (l = 1; l <= i__1; ++l) {
	ip = nsetp + 1 - l;
	if (l == 1) {
	    goto L420;
	}
	i__2 = ip;
	for (ii = 1; ii <= i__2; ++ii) {
/* L410: */
	    zz[ii] -= a[ii + jj * a_dim1] * zz[ip + 1];
	}
L420:
	jj = index[ip];
/* L430: */
	zz[ip] /= a[ip + jj * a_dim1];
    }
    switch (next) {
	case 1:  goto L200;
	case 2:  goto L320;
    }
/* ******** FORMAT DELETED FOR PRINT STATEMENT HERE **************** */
    return 0;
} /* nnls_ */

/* Subroutine */ int g2_(doublereal *cosa, doublereal *sina, doublereal *x, 
	doublereal *y)
{
    static doublereal z__;

/*      IMPLICIT DOUBLE PRECISION (A-H,O-Z) */
/* $$$$ CALLS NO OTHER ROUTINES */
/*  ROTATES A 2-VECTOR (X,Y) BY ANGLE A. OVER-WRITES ORIGINAL VECTOR */

    z__ = *cosa * *x + *sina * *y;
    *y = *cosa * *y - *sina * *x;
    *x = z__;
    return 0;
} /* g2_ */

/* Subroutine */ int g1_(doublereal *a, doublereal *b, doublereal *cosa, 
	doublereal *sina, doublereal *sig)
{
    /* System generated locals */
    doublereal d__1;

    /* Builtin functions */
    double sqrt(doublereal), d_sign(doublereal *, doublereal *);

    /* Local variables */
    static doublereal zero, xr, yr, one;

/*      IMPLICIT DOUBLE PRECISION (A-H,O-Z) */
/* $$$$$ CALLS NO OTHER ROUTINES */




/*  FROM LAWSON+HANSON -SOLVING LEAST SQUARES PROBLEMS- 1974 P 309. */
/*  COMPUTES AN ORTHOGONAL MATRIX TO ROTATE (A,B) INTO (SQRT(A*A+B*B */
/*  MATRIX IN FORM (COSA, SINA/-SINA, COSA) AND SIG HOLDS MAGNITUDE OF */
/*  (A,B).  SIG IS ALLOWED TO OVERWRITE A OR B IN CALLING ROUTINE. */

    zero = 0.f;
    one = 1.f;
    if (abs(*a) <= abs(*b)) {
	goto L10;
    }
    xr = *b / *a;
/* Computing 2nd power */
    d__1 = xr;
    yr = sqrt(one + d__1 * d__1);
    d__1 = one / yr;
    *cosa = d_sign(&d__1, a);
    *sina = *cosa * xr;
    *sig = abs(*a) * yr;
    return 0;
L10:
    if (*b != 0.) {
	goto L20;
    } else {
	goto L30;
    }
L20:
    xr = *a / *b;
/* Computing 2nd power */
    d__1 = xr;
    yr = sqrt(one + d__1 * d__1);
    d__1 = one / yr;
    *sina = d_sign(&d__1, b);
    *cosa = *sina * xr;
    *sig = abs(*b) * yr;
    return 0;
L30:
    *sig = zero;
    *cosa = zero;
    *sina = one;
    return 0;
} /* g1_ */

/* Subroutine */ int h12_(integer *mode, integer *lpivot, integer *l1, 
	integer *m, doublereal *u, integer *iue, doublereal *up, doublereal *
	c__, integer *ice, integer *icv, integer *ncv)
{
    /* System generated locals */
    integer u_dim1, u_offset, i__1, i__2;
    doublereal d__1, d__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer incr;
    static doublereal b;
    static integer i__, j;
    static doublereal clinv;
    static integer i2, i3, i4;
    static doublereal cl, sm, sm1;

/*      IMPLICIT DOUBLE PRECISION (A-H,O-Z) */
/* $$$$$ CALLS NO OTHER ROUTINES */
/*  CONSTRUCTION AND APPLICATION OF HOUSEHOLDER TRANSFORMATION FOR */
/*  MODIFIED FROM  H12  IN LAWSON+HANSEN - SOLVING LEAST SQUARES */
/*  - PRENTICE-HALL 1974 (PP308,309).  DOUBLE PRECISION THROUGHOUT */
    /* Parameter adjustments */
    u_dim1 = *iue;
    u_offset = u_dim1 + 1;
    u -= u_offset;
    --c__;

    /* Function Body */
    if (0 >= *lpivot || *lpivot >= *l1 || *l1 > *m) {
	return 0;
    }
    cl = (d__1 = u[*lpivot * u_dim1 + 1], abs(d__1));
    if (*mode == 2) {
	goto L60;
    }
/*  CONSTRUCT TRANSFORMATION */
    i__1 = *m;
    for (j = *l1; j <= i__1; ++j) {
/* L10: */
/* Computing MAX */
	d__2 = (d__1 = u[j * u_dim1 + 1], abs(d__1));
	cl = max(d__2,cl);
    }
    if (cl <= 0.) {
	goto L130;
    } else {
	goto L20;
    }
L20:
    clinv = 1.f / cl;
/* Computing 2nd power */
    d__1 = u[*lpivot * u_dim1 + 1] * clinv;
    sm = d__1 * d__1;
    i__1 = *m;
    for (j = *l1; j <= i__1; ++j) {
/* L30: */
/* Computing 2nd power */
	d__1 = u[j * u_dim1 + 1] * clinv;
	sm = d__1 * d__1 + sm;
    }
    sm1 = sm;
    cl = sqrt(sm1) * cl;
    if (u[*lpivot * u_dim1 + 1] <= 0.) {
	goto L50;
    } else {
	goto L40;
    }
L40:
    cl = -cl;
L50:
    *up = u[*lpivot * u_dim1 + 1] - cl;
    u[*lpivot * u_dim1 + 1] = cl;
    goto L70;
/*  APLLY TRANSFORMATION */
L60:
    if (cl <= 0.) {
	goto L130;
    } else {
	goto L70;
    }
L70:
    if (*ncv <= 0) {
	return 0;
    }
    b = *up * u[*lpivot * u_dim1 + 1];
    if (b >= 0.) {
	goto L130;
    } else {
	goto L80;
    }
L80:
    b = 1.f / b;
    i2 = 1 - *icv + *ice * (*lpivot - 1);
    incr = *ice * (*l1 - *lpivot);
    i__1 = *ncv;
    for (j = 1; j <= i__1; ++j) {
	i2 = *icv + i2;
	i3 = i2 + incr;
	i4 = i3;
	sm = c__[i2] * *up;
	i__2 = *m;
	for (i__ = *l1; i__ <= i__2; ++i__) {
	    sm = c__[i3] * u[i__ * u_dim1 + 1] + sm;
/* L90: */
	    i3 = *ice + i3;
	}
	if (sm != 0.) {
	    goto L100;
	} else {
	    goto L120;
	}
L100:
	sm = b * sm;
	c__[i2] = sm * *up + c__[i2];
	i__2 = *m;
	for (i__ = *l1; i__ <= i__2; ++i__) {
	    c__[i4] = sm * u[i__ * u_dim1 + 1] + c__[i4];
/* L110: */
	    i4 = *ice + i4;
	}
L120:
	;
    }
L130:
    return 0;
} /* h12_ */

