import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;

/*
 ***************************************************************
 * Silly Sample program which demonstrates the basic paint
 * mechanism for Swing components.
 ***************************************************************
 */
public class SwingPaintDemo {
    public static void main(String[] args) {
        JFrame f = new JFrame("Aim For the Center");
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });

		f.getContentPane().setLayout(new BorderLayout(2,1));

        JComponent panel = new BullsEyePanel();
		panel.setBorder(BorderFactory.createTitledBorder("Image"));
		panel.setPreferredSize(new Dimension(256,256));
		panel.setSize(256,256);
        f.getContentPane().add(panel, BorderLayout.NORTH);

        JSlider slider = new JSlider();
		slider.setBorder(BorderFactory.createTitledBorder("Slider"));
//		slider.setPreferredSize(new Dimension(256, 10));
		slider.setSize(10,256);
        f.getContentPane().add(slider, BorderLayout.SOUTH);

		f.setSize(new Dimension(300,300));

		f.addKeyListener((KeyListener) panel);

        f.pack();
        f.show();
    }
}

/**
 * A Swing container that renders a bullseye background
 * where the area around the bullseye is transparent.
 */
class BullsEyePanel extends JPanel implements KeyListener,MouseMotionListener,MouseListener {

	private MemoryImageSource mi;
	private Image image;
	private int imageData[];
	private Point mouseLoc;

    public BullsEyePanel() {
        super();
        setOpaque(false); // we don't paint all our bits

		createImage();

//		addKeyListener(this);
		addMouseListener(this);
		addMouseMotionListener(this);
    }

//    public Dimension getPreferredSize() {
        // Figure out what the layout manager needs and
        // then add 100 to the largest of the dimensions
        // in order to enforce a 'round' bullseye 
//        Dimension layoutSize = super.getPreferredSize();
//        int max = Math.max(layoutSize.width,layoutSize.height);
//        return new Dimension(max+100,max+100);
//    }

    protected void paintComponent(Graphics g) {
//        Dimension size = getSize();
//        int x = 0;
//        int y = 0;
//        int i = 0;
//        while(x < size.width && y < size.height) {
//            g.setColor(i%2==0? Color.red : Color.white);
//            g.fillOval(x,y,size.width-(2*x),size.height-(2*y));
//            x+=10; y+=10; i++;
//        }

		g.drawImage(image,0,0,256,256,this);
    }

	private void createImage() {
		int jj;

		imageData = new int[256*256];

		for(int ii=0; ii<256*256; ii++) {
			jj = ii%256;
			jj = jj & 0xff;
			imageData[ii] = ((255<<24) | (jj<<16) | (jj<<8) | jj);
		}

		mi = new MemoryImageSource(256,256,imageData,0,256);
		image = createImage(mi);
	}

	public void mouseReleased(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {
		mouseLoc = e.getPoint();
		System.out.println("Mouse Pressed (" + mouseLoc.x + ", " +mouseLoc.y+").");
	}

	public void mouseDragged(MouseEvent e) {}
	public void mouseMoved(MouseEvent e) {
		mouseLoc = e.getPoint();
	}


	public void mouseExited(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}

	public void keyPressed(KeyEvent e) { 
//		System.out.println("keyPressed");
	}

	public void keyReleased(KeyEvent e) { 
//		System.out.println("Key Released");
	}

	public void keyTyped(KeyEvent e) {
		System.out.println("The " + e.getKeyChar() + " key was pressed (" + mouseLoc.x + ", " +mouseLoc.y+").");

		if( e.getKeyChar() == 'q' || e.getKeyChar() == 'Q' ) {
			System.exit(0);
		}
	}
}
