function [] = writebff(filename, data, te, tr)

if( findstr(filename, '.gz') )
	iscompressed = 1;
end

%  Open the file.
if( iscompressed )
	filename_temp = tempname;
	fp = fopen(filename_temp, 'wb', 'l');
else
	fp = fopen(filename, 'wb', 'l');
end

%  Write out the header.
fprintf(fp, 'BFF\n');
fprintf(fp, 'nrows: %d\n', size(data,1));
fprintf(fp, 'ncols: %d\n', size(data,2));

if( length(size(data)) > 3 ) 
	fprintf(fp, 'nslices: %d\n', size(data,3));
	fprintf(fp, 'nchannels: %d\n', size(data,4));
	fprintf(fp, 'nechoes: %d\n', size(data,4));
	fprintf(fp, 'nimages: %d\n', size(data,3)*size(data,4));
else
	fprintf(fp, 'nslices: 1\n', size(data,1));
	fprintf(fp, 'nchannels: %d\n', size(data,3));
	fprintf(fp, 'nechoes: %d\n', size(data,3));
	fprintf(fp, 'nimages: %d\n', size(data,3));
end

tt = sprintf('%3.1f, ', te);
fprintf(fp, 'te: %s\n', tt(1:end-2));

if( length(tr) > 1 )
	tt = sprintf('%3.1f, ', tr);
	fprintf(fp, 'tr: %s\n', tt(1:end-2));
else
	tt = sprintf('%3.1f, ', tr*ones(size(te)));
	fprintf(fp, 'tr: %s\n', tt(1:end-2));
end

fprintf(fp, 'endian: little\n');
fprintf(fp, 'type: short\n');
fprintf(fp, 'comment: This was written out using Matlab.\n');

%  Write out the CTL-L

fprintf(fp, '%c\n', 12);

%  Write out the data.

fwrite(fp, data, 'int16');

fclose(fp);

if( iscompressed )
	unix(sprintf('cat %s | gzip -c > %s', filename_temp, filename));
end
